给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
示例1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例3:
输入:nums = [3,3], target = 6
输出:[0,1]
初看此题时,脑海中只有一个想法,就是暴力求解,两个循环,挨个加一遍就完事了。
class Solution {
public int[] twoSum(int[] nums, int target) {
for(int i=0;i<nums.length-1;i++){
for(int j=i+1;j<nums.length;j++){
if(nums[i]+nums[j] == target){
return new int[]{i,j};
}
}
}
return null;
}
}
暴力虽然很高理解,但是时间复杂度达到了N方。
官方给出了更简便的方法:哈希表
在hash表中找到一个数只需要N(1)的时间复杂度
在我们确定了一个数之后,需要找的另一个数就是target - 当前数
public static int[] twoSum(int[] nums,int target){
Map<Integer,Integer> map = new HashMap<>();
for (int i = 0; i < nums.length; i++) {
if(map.containsKey(target-nums[i])){
return new int[]{i,map.get(target-nums[i])};
}else {
map.put(nums[i],i);
}
}
return null;
}